package KGS::Listener::Channel;

use base KGS::Listener;

sub add_users {
   my ($self, @users) = @_;
   for (@users) {
      $self->{users}{$_->{name}} = $_;
      $self->event_join if $_->{name} eq $self->{conn}{name};
   }
   $self->event_update_users;
}

sub del_users {
   my ($self, @users) = @_;
   for (@users) {
      delete $self->{users}{$_->{name}};
      $self->event_part if $_->{name} eq $self->{conn}{name};
   }
   $self->event_update_users;
}

sub join {
   my ($self, $type) = @_;
   return if $self->{joined};

   $self->msg($type => channel => $self->{channel}, name => $self->{conn}->{name});
   delete $self->{users};
}

sub part {
   my ($self, $type) = @_;
   return unless $self->{joined};

   $self->msg($type => channel => $self->{channel}, name => $self->{conn}->{name});
}

sub event_join {
   my ($self) = @_;
   $self->{joined} = 1;
}

sub event_part {
   my ($self) = @_;
   delete $self->{users};
   $self->{joined} = 0;
}

sub event_update_users {}
sub event_update_games {}

1;



