package KGS::Listener::Game;

use base KGS::Listener::Channel;
use base KGS::Game::Tree;

sub join {
   my ($self) = @_;
   $self->SUPER::join("join_game");
   $self->init_tree unless $self->{joined};
}

sub part {
   my ($self) = @_;
   $self->SUPER::join("part_game");
}

sub say {
   my ($self, $msg) = @_;
   die;
}

sub inject_upd_observers {
   my ($self, $msg) = @_;
   return unless $msg->{channel} == $self->{channel};

   $self->add_users(@{$msg->{users}});
}

sub inject_del_observer {
   my ($self, $msg) = @_;
   return unless $msg->{channel} == $self->{channel};

   $self->del_users($msg);
}

sub inject_set_tree {
   my ($self, $msg) = @_;
   return unless $msg->{channel} == $self->{channel};

   $self->update_tree($msg->{tree});
   $self->event_update_tree unless $self->{more};
}

sub inject_upd_tree {
   my ($self, $msg) = @_;
   return unless $msg->{channel} == $self->{channel};

   $self->update_tree($msg->{tree});
   $self->event_update_tree;
}

sub inject_set_node {
   my ($self, $msg) = @_;
   return unless $msg->{channel} == $self->{channel};

   $self->set_node($msg->{node});
   $self->event_update_tree;
}

1;



