package KGS::Listener::Room;

use base KGS::Listener::Channel;

sub join {
   my ($self) = @_;
   $self->SUPER::join("join_room");
}

sub part {
   my ($self) = @_;
   $self->SUPER::join("part_room");
}

sub say {
   my ($self, $msg) = @_;
   $self->msg(msg_room => channel => $self->{channel}, name => $self->{conn}{name}, message => $msg);
}

sub update_roominfo {
   my ($self) = @_;

   $self->msg(desc_room => channel => $self->{channel});
}

sub inject_join_room {
   my ($self, $msg) = @_;
   return unless $msg->{channel} == $self->{channel};

   $self->add_users(@{$msg->{users}});
}

sub inject_part_room {
   my ($self, $msg) = @_;
   return unless $msg->{channel} == $self->{channel};

   $self->del_users($msg);
}

sub inject_upd_games {
   my ($self, $msg) = @_;
   return unless $msg->{channel} == $self->{channel};

   for (@{$msg->{games}}) {
      $self->{games}{$_->{channel}} = $_;
   }
   $self->event_update_games;
}

sub inject_upd_game {
   my ($self, $msg) = @_;
   return unless exists $self->{games}{$msg->{game}{channel}};

   $self->{games}{$msg->{game}{channel}} = $msg->{game};
   $self->event_update_games;
}

# broken protocol, eh? ;)
sub inject_del_game {
   my ($self, $msg) = @_;

   delete $self->{games}{$msg->{channel}};
   $self->event_update_games;
}

sub inject_msg_room {
   my ($self, $msg) = @_;
   return unless $msg->{channel} == $self->{channel};

   $self->{text}->insert(undef, undef, undef, "$msg->{mesage}\n");
}

sub inject_desc_room {
   my ($self, $msg) = @_;
   return unless $msg->{channel} == $self->{channel};

   $self->{owner}       = $msg->{owner};
   $self->{description} = $msg->{description};

   $self->event_update_roominfo;
}

sub event_part {
   my ($self) = @_;
   $self->SUPER::event_part;
   delete $self->{games};
}

sub event_update_roominfo { }

1;



